//program to calculate expectation energy
#include <iostream.h>
#include <strstream.h>

#include "userinfo.h"
#include "userutil.h"
#include "ryspoly.h"

int parainput(int argc,char **argv,char *foutname,int *nrys)
{ int k,error;
  float xa;

  error=0;
  Textout conout;

  k=1;
  if (error==0)
  { conout.string("Enter name of output rys roots and factors file",
      0,1);
    if (argc<=k) cin >> foutname;
    else
    { istrstream tempbuf(argv[1]);
      tempbuf >> foutname;
      conout.string(foutname,0,1);
    }
    ++k;
  }

  if (error==0)
  { conout.string(
      "Enter order of Rys polynomial (0-7, 0 means all) ");
    if (argc<=k) cin >> xa;
    else
    { istrstream tempbuf(argv[k]);
      tempbuf >> xa;
      conout.integer((int)xa,0,1);
    }
    *nrys=(int)xa;
    if (*nrys>0) ++*nrys;
    ++k;
  }

  if (error==0) conout.newline();

  return(error);
} //end of parainput

int main(int argc,char **argv)
{ int help,nrys,error;
  float xa;
  char foutname[80];

  error=0; foutname[0]='\0';
  Userinfo userinfo; userinfo.init();
  userinfo.loadparameter(1.01f,"rysroot",
    "Y Chen, G Zhuang, PN Ross, MA Van Hove and CS Fadley",
    "Calculation of roots and weight factors of Rys polynomial");
  Textout conout;
  conout.string(userinfo.usermsg,0,1);
  if (userinfo.version==0.0) error=102;

  if ((error==0)&&(argc>1))
  { help=stringcomp(argv[1],"help",5);
    if (help!=0) help=stringcomp(argv[1],"?",2);
    if (help!=0) help=stringcomp(argv[1],"\\?",3);
    if (help!=0) help=stringcomp(argv[1],"/?",3);
  }
  else help=1;

  if ((error==0)&&(help!=0))
    error=parainput(argc,argv,foutname,&nrys);

  if ((error==0)&&(help!=0))
  { Ryspoly ryspoly; ryspoly.init();
    error=ryspoly.makeroots(nrys);
    if (error==0)
    { xa=ryspoly.getmemory();
      xa=xa*1.0e-6f+0.1f;
      conout.string("This job took ");
      conout.floating(xa,7.1f);
      conout.string(" megabytes memory",0,2);
    }
    if (error==0) error=ryspoly.saveroots(foutname,userinfo.usermsg);
  }
  else if (error==0)
  { conout.string("Usage:   rysroots output_filename rys_order",0,16+2);
    conout.string("         output_filename:  name of output ");
    conout.string("Rys roots and weight factor file",0,1);
    conout.string("         rys_order (0-7):  order of Rys polynomial");
    conout.string(" (0 means all)",0,2);
    conout.string("Example: rysroot rysroot.txt 0",0,16+1);
  }

  Errorinfo errorinfo(error);
  conout.string(errorinfo.errmsg,0,16+1);

  return(error);
} //end of main


/*
----------------------------------------------------------------------
RYSROOT version history


RYSROOT root searching program was started on August 18, 1997, using
ANSI C++ object oriented programming (OOP) technique.

Version 1.00, September 5, 1997
  First version, working on PC, Sun workstation, Cray J90

Version 1.01, Septermber 9, 1997
  Calculate roots and weight factors for large xa value asymptotically,
  more accurate and faster



Reference
  H.F. King and M. Dupuis, Numerical integration using rys polynomials,
  J. Computational Physics 21, 144-165 (1976)

----------------------------------------------------------------------
*/

