#include <strstream.h>

#include "userinfo.h"

Userinfo::Userinfo(int imype,int inumpe)
{ mype=imype; numpe=inumpe; error=107; init();
} //end of Userinfo::Userinfo

Userinfo::~Userinfo()
{ if (author) delete [] author; if (usermsg) delete [] usermsg;
} //end of Userinfo::~Userinfo

void Userinfo::init()
{ if ((error==107)||(error==103))
  { author=usermsg=NULL;
  }
  if (error==103)
  { author=new char [80]; usermsg=new char [1024];
    if ((!author)||(!usermsg)) error=102;
  }
  else if (error==106)
  { if (author)
    { author=new char [80]; if (!author) error=102;
    }
    if (usermsg)
    { usermsg=new char [1024]; if (!usermsg) error=102;
    }
  }
  if (error==106) error=0;
  else if (error==103) error=101;
  else if (error==107) error=103;

  return;
} //end of Userinfo::init

int Userinfo::loadparameter(float iversion,char *filename,
  char *iauthor,char *title,int machine)
{ int i,j,k,leng;
  char dashline[80];

  if ((error==101)||(error==0))
  { error=0;
    if (iversion<1.00) version=1.0f;
    else if (iversion>10.0) version=10.0f;
    else version=iversion;
    version+=1.0e-3f;
    ostrstream membuf(usermsg,1024);
    for (i=0;i<52;++i)
    { if (iauthor[i]!='\0') author[i]=iauthor[i];
      else break;
    }
    author[i]='\0'; leng=i;
    for (i=0;i<65;++i) dashline[i]='-';
    dashline[i]='\0';
    membuf << dashline << endl;
    membuf << title << endl;
    membuf << filename;
    for (i=0;i<12;++i) if (filename[i]=='\0') break;
    leng+=i;
    if (error==0) k=sizeof(int); else k=sizeof(int);
    if (machine>100)
    { membuf << " Parallel "; leng+=10;
    }
    else if (k<4)
    { membuf << " 16 Bit "; leng+=8;
    }
    if (leng<52) membuf << "Version "; else membuf << " ";
    i=(int)version; j=(int)(version*10.0)-i*10;
    k=(int)(version*100.0)-i*100-j*10;
    membuf << i << '.' << j << k << ' ' << author << endl;
    membuf << "Lawrence Berkeley National Laboratory (LBNL),"
      << " Berkeley, CA 94720" << endl;
    membuf << "Copyright (c) Van Hove Group 1997."
      << " All rights reserved" << endl;
    membuf << dashline << endl << ends;
  }
  else
  { version=0.0f;
  }
  return(error);
} //end of Userinfo::Userinfo

float Userinfo::getmemory()
{ float xa;
  xa=(float)(sizeof(Userinfo)+(1024+64)*sizeof(char));
  return(xa);
} //end of Userinfo::getmemory

Errorinfo::Errorinfo(int errorcode)
{ int filecode,subcode,length;

  error=errorcode; errmsg=NULL;
  length=100; errmsg=new char [length];
  if ((errmsg)&&(error!=0))
  { ostrstream membuf(errmsg,length);
    subcode=(errorcode&0xffff);
    filecode=(errorcode>>16);
    if ((subcode>=1000)||(subcode==0)) subcode=901;
    membuf << "Error " << subcode;
    if ((subcode/10 != 20) && (subcode/10 != 70) &&
      (subcode/10 != 71)) filecode=0;
    else if ((filecode > 100) && (filecode < 300))
      membuf << ", photoemission";
    else if ((filecode >= 300) && (filecode < 500))
      membuf << ", photoemission";
    else if ((filecode >= 710) && (filecode < 720))
      membuf << ", phase shift";
    else if ((filecode >= 720) && (filecode < 730))
      membuf << ", radial matrix";
    else if ((filecode >= 730) && (filecode < 740))
      membuf << ", report";
    else if ((filecode >= 740) && (filecode < 750))
      membuf << ", mscd input";
    else if ((filecode >= 750) && (filecode < 760))
      membuf << ", batch input";
    else if ((filecode >= 810) && (filecode < 820))
      membuf << ", potential";
    else if ((filecode >= 820) && (filecode < 830))
      membuf << ", psrm input";
    else if ((filecode >= 830) && (filecode < 840))
      membuf << ", eigen wave";
    else if ((filecode >= 910) && (filecode < 920))
      membuf << ", hologram";
    else if ((filecode >= 920) && (filecode < 930))
      membuf << ", holo input";
    else if ((filecode >= 930) && (filecode < 940))
      membuf << ", scattering factor";
    else if ((filecode >= 940) && (filecode < 950))
      membuf << ", mean free path";
    else if ((filecode >= 950) && (filecode < 960))
      membuf << ", thermal vibration";
    else if (filecode==961)
      membuf << ", expectation";
    else if (filecode==962)
      membuf << ", gaussain output";
    else if (filecode==963)
      membuf << ", relaxation";
    else if (filecode==964)
      membuf << ", rys roots";
    else
      membuf << ",";

    if (subcode == 101)
      membuf << " data not ready";
    else if (subcode == 102)
      membuf << " out of memory";
    else if (subcode == 103)
      membuf << " memory not ready";
    else if (subcode == 104)
      membuf << " out of allocated memory";
    else if (subcode == 105)
      membuf << " integer size too short";
    else if (subcode == 106)
      membuf << " memory not imported";
    else if (subcode == 107)
      membuf << " memory not flushed";
    else if (subcode == 201)
      membuf << " file not found";
    else if (subcode == 202)
      membuf << " file open error";
    else if (subcode == 203)
      membuf << " file creation error";
    else if (subcode == 204)
      membuf << " data reading error";
    else if (subcode == 205)
      membuf << " data writing error";
    else if (subcode == 206)
      membuf << " end-of-file reading error";
    else if (subcode == 207)
      membuf << " data format error";
    else if (subcode == 208)
      membuf << " no data available";
    else if (subcode == 209)
      membuf << " data type error";
    else if (subcode == 211)
      membuf << " singular matrix error";
    else if (subcode == 601)
      membuf << " too few atoms (no or one)";
    else if (subcode == 602)
      membuf << " too many atoms";
    else if (subcode == 603)
      membuf << " too many kinds of atoms";
    else if (subcode == 604)
      membuf << " emitter not found";
    else if (subcode == 605)
      membuf << " too small distance between atoms";
    else if (subcode == 611)
      membuf << " no available experimental data";
    else if (subcode == 612)
      membuf << " experimental chi data too small";
    else if (subcode == 613)
      membuf << " data files not match";
    else if (subcode == 614)
      membuf << " too few input data points";
    else if (subcode == 615)
      membuf << " too many input data points";
    else if (subcode == 616)
      membuf << " too few output data points";
    else if (subcode == 617)
      membuf << " too many output data points";
    else if (subcode == 618)
      membuf << " no available hologram data";
    else if (subcode == 621)
      membuf << " symmetry search error";
    else if (subcode == 622)
      membuf << " symmetry order error";
    else if (subcode == 623)
      membuf << " subshell name error";
    else if (subcode == 624)
      membuf << " binding energy adjustment error";
    else if (subcode == 625)
      membuf << " binding energy may be too small";
    else if (subcode == 626)
      membuf << " binding energy may be too large";
    else if (subcode == 627)
      membuf << " binding energy be too small";
    else if (subcode == 628)
      membuf << " binding energy be too large";
    else if (subcode == 631)
      membuf << " output file name not found";
    else if (subcode == 632)
      membuf << " duplicate output file name";
    else if (subcode == 633)
      membuf << " list file open error";
    else if (subcode == 641)
      membuf << " too few fitting parameters";
    else if (subcode == 642)
      membuf << " too many fitting parameters";
    else if (subcode == 701)
      membuf << " too few data points";
    else if (subcode == 702)
      membuf << " too many data points";
    else if (subcode == 703)
      membuf << " too few curves";
    else if (subcode == 704)
      membuf << " too many curves";
    else if (subcode == 705)
      membuf << " no available data";
    else if (subcode == 706)
      membuf << " data too small";
    else if (subcode == 707)
      membuf << " data order error";
    else if (subcode == 711)
      membuf << " energy order error";
    else if (subcode == 712)
      membuf << " energy step too small";
    else if (subcode == 713)
      membuf << " too few energy points";
    else if (subcode == 714)
      membuf << " too many energy points";
    else if (subcode == 715)
      membuf << " too few angle points";
    else if (subcode == 716)
      membuf << " too many angle points";
    else if (subcode == 717)
      membuf << " zero or negative energy";
    else if (subcode == 751)
      membuf << " message sending error";
    else if (subcode == 752)
      membuf << " message receiving error";
    else if (subcode == 753)
      membuf << " received empty message";
    else if (subcode == 754)
      membuf << " received error message";
    else if (subcode == 761)
      membuf << " too many processors";
    else if (subcode == 901)
      membuf << " programming error occured";
    else if (subcode == 999)
      membuf << " unknown error occured";
    else
      membuf << " unknown error occured";

    membuf << ", program terminated" << ends;
  }
  else if (errmsg)
  { ostrstream membuf(errmsg,length);
    membuf << "Program terminated normally" << ends;
  }
  else if (error==0) error=102;
} //end of Errorinfo::Errorinfo

Errorinfo::~Errorinfo()
{ delete [] errmsg;
} //end of Errorinfo::~Errorinfo

float Errorinfo::getmemory()
{ float xa;
  xa=(float)(sizeof(Errorinfo)+100*sizeof(char));
  return(xa);
} //end of Userinfo::getmemory


